unit Unit1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Controls,
  Forms,
  //Dialogs,
  StdCtrls,
  Cddb,
  AspiCD;

const
  WM_READ = WM_USER + 1024;

type
  TForm1 = class( TForm )
    Cddb : TCddb;
    Memo1 : TMemo;
    Button1 : TButton;
    Button2 : TButton;
    Edit1 : TEdit;
    Edit2 : TEdit;
    Button3 : TButton;
    Button4 : TButton;
    Button5 : TButton;
    Button6 : TButton;
    Button7 : TButton;
    Button8 : TButton;
    Button9 : TButton;
    Button10 : TButton;
    Button11 : TButton;
    Button12 : TButton;
    Button14 : TButton;
    Button15 : TButton;
    CbDrives : TComboBox;
    Edit3 : TEdit;
    Button13 : TButton;
    //Label1 : TLabel;
    Button17 : TButton;
    Button18 : TButton;
    Button19 : TButton;
    Button20 : TButton;
    Button21 : TButton;
    Button22 : TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Edit4: TEdit;
    Edit5: TEdit;
    procedure Button1Click( Sender : TObject );
    procedure Button2Click( Sender : TObject );
    procedure CddbStatusMessage( Sender : TObject; Status : string );
    procedure CddbDataExchange( Sender : TObject; Status : string );
    procedure Button3Click( Sender : TObject );
    procedure Button4Click( Sender : TObject );
    procedure Button5Click( Sender : TObject );
    procedure Button6Click( Sender : TObject );
    procedure Button7Click( Sender : TObject );
    procedure Button8Click( Sender : TObject );
    procedure CddbMatch( Sender : TObject; Matches : TMatchArray;
      var RightOne : Integer );
    procedure Button9Click( Sender : TObject );
    procedure Button10Click( Sender : TObject );
    procedure Button11Click( Sender : TObject );
    procedure FormCreate( Sender : TObject );
    procedure Button12Click( Sender : TObject );
    procedure Button14Click( Sender : TObject );
    procedure Button15Click( Sender : TObject );
    procedure Button16Click( Sender : TObject );
    procedure CbDrivesChange( Sender : TObject );
    procedure Button13Click( Sender : TObject );
    procedure Button17Click( Sender : TObject );
    procedure Button18Click( Sender : TObject );
    procedure Button19Click( Sender : TObject );
    procedure Button20Click( Sender : TObject );
    procedure Button21Click( Sender : TObject );
    procedure Button22Click( Sender : TObject );
    procedure Button23Click(Sender: TObject);
    procedure WMRead( var msg: TMessage ); message WM_READ;
    procedure Button24Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 : TForm1;
  BatchRead : Boolean = False;

implementation
{$R *.dfm}

procedure TForm1.Button1Click( Sender : TObject );
begin
  CDDB.ServerAddr := Edit1.Text;
  CDDB.ServerPort := Edit2.Text;
  CDDB.Connect( );
end;

procedure TForm1.Button2Click( Sender : TObject );
begin
  CDDB.Quit( );
end;

procedure TForm1.CddbStatusMessage( Sender : TObject; Status : string );
begin
  Memo1.Lines.Add( Status );
end;

procedure TForm1.CddbDataExchange( Sender : TObject; Status : string );
begin
  Memo1.Lines.Add( Status );
end;

procedure TForm1.Button3Click( Sender : TObject );
begin
  CDDB.SendHello( );
end;

procedure TForm1.Button4Click( Sender : TObject );
begin
  CDDB.GetSites;
end;

procedure TForm1.Button5Click( Sender : TObject );
var
  i : integer;
begin
  // This shows some of the sites information

  for i := 0 to 99 do
  begin
    if CDDB.Servers[i].Address = '' then
      break;
(*
    ShowMessage( 'Addr: ' + CDDB.Servers[i].Address + #13#10 +
      'AdditionalAddr: ' + CDDB.Servers[i].AdditionalAddress + #13#10 +
      'Port: ' + IntToStr( CDDB.Servers[i].Port ) + #13#10 +
      'Description: ' + CDDB.Servers[i].Location.Description );
*)
    MessageBox( Handle, PChar( 'Addr: ' + CDDB.Servers[i].Address + #13#10 +
      'AdditionalAddr: ' + CDDB.Servers[i].AdditionalAddress + #13#10 +
      'Port: ' + IntToStr( CDDB.Servers[i].Port ) + #13#10 +
      'Description: ' + CDDB.Servers[i].Location.Description ), 'Info', 0 )
  end;
end;

procedure TForm1.Button6Click( Sender : TObject );
begin
  CDDB.Proto( );
end;

procedure TForm1.Button7Click( Sender : TObject );
begin
  CDDB.Query( );
end;

procedure TForm1.Button8Click( Sender : TObject );
begin
  CDDB.Read( );
end;

procedure TForm1.CddbMatch( Sender : TObject; Matches : TMatchArray;
  var RightOne : Integer );
begin
  RightOne := 0;

  If BatchRead and ( CDDB.ServerType = HTTP ) then
  begin
    //Here we make a HTTP Query - HTTP Read batch.
    PostMessage( Handle, WM_READ, Integer( Sender ), 0 );
    BatchRead := False;
  end;
end;

procedure TForm1.Button9Click( Sender : TObject );
var
  Entry : string;
  i : integer;
begin
  //  CDDB.ParseCurrentEntry;
  i := 0;
  Entry := '';
  repeat
    Entry := Entry + CDDB.CurrentEntry[i] + #13#10;
    i := i + 1;
  until ( i = 511 ) or ( CDDB.CurrentEntry[i] = '' );
  (*
  showmessage( inttostr( i ) );
  showmessage( Entry );
  *)
  MessageBox( Handle, PChar( inttostr( i ) ), 'Info', 0 );
  MessageBox( Handle, PChar( Entry ), 'Info', 0 );
end;

procedure TForm1.Button10Click( Sender : TObject );
begin
  CDDB.OnDataExchange := nil;
end;

procedure TForm1.Button11Click( Sender : TObject );
begin
  CDDB.OnStatusMessage := nil;
end;

procedure TForm1.FormCreate( Sender : TObject );
var
  i : byte;
begin
  with CDDB.CdRoms do
  begin
    for i := 0 to CdRomCount - 1 do
    begin
      (*
            CbDrives.Items.Add( CdRom[i].Vendor + CdRom[i].ProductId +
              CdRom[i].Revision );
      *)
      CbDrives.Items.Add( CdRom[i].Description );
    end;
  end;
  CbDrives.ItemIndex := 0;
  CbDrivesChange( Self );
  {
    ZeroMemory( @( CDDB.CDInfo.CDToc ), SizeOf( CDDB.CDInfo.CDToc ) );
    with CDDB.CDInfo.CDToc do
    begin
      TracksOnCD := 10;

      Tracks[0].M := 0;
      Tracks[0].S := 2;
      Tracks[0].F := 0;

      Tracks[1].M := 2;
      Tracks[1].S := 55;
      Tracks[1].F := 2;

      Tracks[2].M := 6;
      Tracks[2].S := 50;
      Tracks[2].F := 70;

      Tracks[3].M := 10;
      Tracks[3].S := 52;
      Tracks[3].F := 15;

      Tracks[4].M := 14;
      Tracks[4].S := 30;
      Tracks[4].F := 60;

      Tracks[5].M := 18;
      Tracks[5].S := 42;
      Tracks[5].F := 25;

      Tracks[6].M := 23;
      Tracks[6].S := 47;
      Tracks[6].F := 7;

      Tracks[7].M := 27;
      Tracks[7].S := 47;
      Tracks[7].F := 72;

      Tracks[8].M := 31;
      Tracks[8].S := 52;
      Tracks[8].F := 65;

      Tracks[9].M := 36;
      Tracks[9].S := 18;
      Tracks[9].F := 35;

      for i := 0 to 9 do
      begin
        Tracks[i].AudioTrack := True;
      end;

      LeadOut.M := 40;
      LeadOut.S := 7;
      LeadOut.F := 10;
      LeadOut.AudioTrack := False;

    end;
  }

  Cddb.LocalCDDBPath := ExtractFilePath( Application.ExeName );

end;

procedure TForm1.Button12Click( Sender : TObject );
begin
  CDDB.ServerAddr := Edit1.Text;
  CDDB.ServerAdditionalAddr := '/~cddb/cddb.cgi';
  CDDB.ServerType := HTTP;
  CDDB.ServerPort := '80';
  CDDB.http_query;
  // showmessage(CDDB.CDInfo.Category);
end;

procedure TForm1.Button14Click( Sender : TObject );
begin
  // showmessage(CDDB.CDInfo.Category);
  CDDB.ServerAddr := Edit1.Text;
  CDDB.ServerAdditionalAddr := '/~cddb/cddb.cgi';
  CDDB.ServerType := HTTP;
  CDDB.ServerPort := '80';
  CDDB.http_read;
  // showmessage(CDDB.CDInfo.Category);
end;

procedure TForm1.Button15Click( Sender : TObject );
begin
  //  MessageBox(Form1.Handle, CDDB.CDInfo.Category, 'Something', 0);
  // The CDToc must be reset.
  // Button13Click( Self );  //Not anymore!

  CDDB.SubmissionType := TEST;  //Change to SUBMIT to make real submissions

  CDDB.ServerAddr := Edit1.Text;
  CDDB.ServerAdditionalAddr := '/~cddb/cddb.cgi';
  CDDB.ServerType := HTTP;
  CDDB.ServerPort := '80';
  CDDB.http_submit;
  //  showmessage(CDDB.CDInfo.Category);
end;

procedure TForm1.Button16Click( Sender : TObject );
begin
  CDDB.ServerAddr := Edit1.Text;
  CDDB.ServerAdditionalAddr := '/~cddb/cddb.cgi';
  CDDB.ServerType := HTTP;
  CDDB.ServerPort := '80';
  CDDB.http_sites;
end;

procedure TForm1.CbDrivesChange( Sender : TObject );
begin
  CDDB.ChangeActiveDrive( CbDrives.ItemIndex );
  Edit3.Text := CDDB.GetActiveDriveLetter + ':';
end;

procedure TForm1.Button13Click( Sender : TObject );
var
  Letter : Char;
begin

  Letter := string( Copy( Edit3.Text, 0, 1 ) )[1];
  CDDB.ChangeActiveDrive( Letter );
  CbDrives.ItemIndex := CDDB.GetActiveDrive;
end;

procedure TForm1.Button17Click( Sender : TObject );
begin
  (*
   This parses CDDB.CDInfo and forms an entry from the data.
   The DLL parser, ParseEntry, can be used instead of the one
   used here.
  *)

  Cddb.ParseCurrentEntry;
end;

procedure TForm1.Button18Click( Sender : TObject );
begin
  // This can be used to check whether parsing the entry has been successful

  with CDDB do
(*
    showmessage( CDInfo.DiscID + #13#10 + CDInfo.Artist + #13#10 + CDInfo.Title
      + #13#10
      + CDInfo.Year + #13#10 + CDInfo.Genre + #13#10 + CDInfo.Category + #13#10
      + CDInfo.AddAlbumInfo + #13#10 + CDInfo.Tracks[0] + #13#10 + '''' +
      CDInfo.AddTrkInfo[0] + '''' );
*)
  MessageBox( Handle, PChar( CDInfo.DiscID + #13#10 + CDInfo.Artist + #13#10 + CDInfo.Title
      + #13#10
      + CDInfo.Year + #13#10 + CDInfo.Genre + #13#10 + CDInfo.Category + #13#10
      + CDInfo.AddAlbumInfo + #13#10 + CDInfo.Tracks[0] + #13#10 + '''' +
      CDInfo.AddTrkInfo[0] + '''' ), 'Info', 0 );
end;

procedure TForm1.Button19Click( Sender : TObject );
var
  i : integer; //Entry : TEntryArray;
begin
  // This clears the entry.

  //  Entry := CDDB.CurrentEntry;
  for i := 0 to 511 do
  begin
    CDDB.CurrentEntry[i] := '';
  end;
  //  CDDB.CurrentEntry := Entry;
end;

procedure TForm1.Button20Click( Sender : TObject );
//var CDInfo : TCDInfo;
begin
  // This is to test if
  // a) Creating an entry from an info record is working
  // b) CDDB.CDInfo can be edited

  //  Cddb.CDInfo.AddTrkInfo[0] := 'Bleech...this tune sucks.';

  //Cddb.FormEntry;
  Cddb.FormCurrentEntry;
end;

procedure TForm1.Button21Click( Sender : TObject );
begin
  //If you want to read a SPECIFIC entry, you have
  //to enter a category retrieved with FindMatches
  Cddb.CDInfo.Category := #0;
  if Cddb.ReadInfoFromLocalCDDB < 0 then
  begin
    (*
    showmessage( InttoStr( CDDB.ReadInfoFromLocalCDDB ) );
    *)
      MessageBox( Handle, PChar( InttoStr( CDDB.ReadInfoFromLocalCDDB ) ), 'Info', 0 );
      Cddb.RefreshDrives; //If the file's not found, the TOC is lost. Reretrieve.
  end;
end;

procedure TForm1.Button22Click( Sender : TObject );
begin
  if Cddb.SaveInfoToLocalCDDB < 0 then
  begin
    (*
    showmessage(  );
    *)
    MessageBox( Handle, PChar( InttoStr( CDDB.SaveInfoToLocalCDDB ) ), 'Info', 0 );
  end;
end;

procedure TForm1.Button23Click(Sender: TObject);
{
var
  FindMatches : TFindMatches;
  Matches : TMatchArray;
  CMatches : array[0..99] of array[0..511] of Char;
  hDll : THandle;
  i : integer;
  FilePath : PChar;
  Test : Pointer;
  CFilePath : array[0..MAX_PATH - 1] of Char;
  CppInfo : TCppCDInfo;

begin
  hDll := LoadLibrary( PChar( Cddb.LocalCDDBPath ) );
  FindMatches := GetProcAddress( hDll, 'FindMatches' );
  for i := 0 to 99 do
  begin
    ZeroMemory( @CMatches[i][0], 512 );
    Matches[i] := @CMatches[i][0];
  end;

  ZeroMemory( @CFilePath, MAX_PATH );
  StrPCopy( @CFilePath, ExtractFilePath( Cddb.LocalCDDBPath ) );
  FilePath := @CFilePath;


  CppInfo := ConvertInfoPtoCpp( Cddb.CDInfo^ );
  showmessage( InttoStr( FindMatches( @CppInfo, FilePath, False, Matches ) ) );

  showmessage( Matches[0] );
  FreeLibrary( hDll );


  //Testing dynamic allocation
  GetMem( Test, 512 );
  showmessage( PChar( Test ) );
  ZeroMemory( Test, 512 );
{
  ( PChar( Test ) )^ := #13;
  ( PChar( Test ) + 1 )^ := #10;
  ( PChar( Test ) + 2 )^ := #65;
  ( PChar( Test ) + 3 )^ := #0;
}
{
  //PChar( Test ) := 'Sheesh...'+ #13#10#65#0;  //This won't work since Delphi messes it up
  StrPCopy( PChar( Test ), 'Sheesh...'+ #13#10#65#0 );

  showmessage( '''' + PChar( Test ) + '''' );
  FreeMem( Test );
  //Dispose( Test );

  //Test := Pointer( $00400000 );

  //Showmessage( PChar( Test ) );

  Test := nil;
}
var Matches : TMatches;
begin
  Matches := CDDB.FindMatchesFromLocalCDDB;
  //showmessage( '''' + Matches[0].Category + '''' + #13#10 + '''' + Matches[0].DiscID + '''' );

  MessageBox( Handle, PChar(
  '''' + Matches[0].Category + '''' + #13#10 + '''' + Matches[0].DiscID + '''' ),
  'Info', 0 );
end;

procedure TForm1.WMRead( var msg: TMessage );
var DaCDDB : TCddb;
begin
  DaCDDB := TCddb( msg.WParam );
  with DaCDDB do
  if ( State = CS_MATCH ) or ( State = CS_MULTIMATCH ) then
  begin
    http_read;
  end;
end;

procedure TForm1.Button24Click(Sender: TObject);
begin
  BatchRead := True;
  CDDB.ServerAddr := Edit1.Text;
  CDDB.ServerAdditionalAddr := '/~cddb/cddb.cgi';
  CDDB.ServerType := HTTP;
  CDDB.ServerPort := '80';
  CDDB.http_query;
end;

procedure TForm1.Button25Click(Sender: TObject);
begin
  // I hope your connection settings are OK...
  If ( Edit4.Text = '' ) or ( Edit5.Text = '' ) then
  begin
    MessageBox( Handle, 'SMTP mail server address or port is empty!', 'Error', 0 );
    Exit;
  end;

  Cddb.SubmissionType := TEST;
  Cddb.MailServerAddress := Edit4.Text;
  Cddb.MailServerPort := Edit5.Text; //'smtp';

  Cddb.smtp_submit;
end;

end.

